#ifndef __IMFFLOW_H__
#define __IMFFLOW_H__
#include <MFNVector.h>
#include <MFNKMatrix.h>

#ifdef __cplusplus
extern "C"
 {
#endif

struct IMFFlowSt;
typedef struct IMFFlowSt *IMFFlow;

IMFFlow IMFCreateFlow(int,void (*)(double*,double*),
                          void (*)(double*,double*),
                          void (*)(double*,double*),
                          void (*)(double*,double*));
IMFFlow IMFCreateFatFlow(IMFFlow,int);
IMFFlow IMFCreateBackwardFatFlow(IMFFlow,int);
IMFFlow IMFCreateBackwardFlow(IMFFlow);
void IMFFreeFlow(IMFFlow);
void IMFRefFlow(IMFFlow);
void IMFEvaluateFlow(IMFFlow,MFNVector,double*);
void IMFEvaluateDerivativeOfFlow(IMFFlow,MFNVector,double*);
void IMFEvaluateSecondDerivativeOfFlow(IMFFlow,MFNVector,double*);
void IMFEvaluateThirdDerivativeOfFlow(IMFFlow,MFNVector,double*);
int IMFFlowN(IMFFlow);
double IMFFlowR(IMFFlow,double,MFNVector,MFNKMatrix);

#ifdef __cplusplus
 }
#endif

#endif
