/* 
    @(#)MFBinaryTree.h	1.5
    02/07/26 09:10:35
   
    PROGRAM NAME:  Manifold
    
    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.
    
    Please refer to the LICENSE file in the top directory 

*/
/*      author: Mike Henderson mhender@watson.ibm.com */

#ifndef __MFBINARYTREE_H__
#define __MFBINARYTREE_H__
#include <MFBase.h>
#include <MFChart.h>
#include <MFListOfCharts.h>

#ifdef __cplusplus
extern "C"
 {
#endif
struct MFBinaryTreeSt;
typedef struct MFBinaryTreeSt *MFBinaryTree;

MFBinaryTree MFCreateBinaryTree(int);
void MFFreeBinaryTree(MFBinaryTree);

void MFBinaryTreeAddChart(MFBinaryTree,int,double*,double);

MFListOfCharts MFCreateListOfIntersectingCharts(MFBinaryTree,int,double*,double);
MFListOfCharts MFCreateListOfNearbyCharts(MFBinaryTree,double*,double);

void MFWriteBinaryTree(FILE*,MFBinaryTree);
MFBinaryTree MFReadBinaryTree(FILE*);
void MFRecomputeBoundingBoxes(MFBinaryTree,int,double*,double);
#ifdef __cplusplus
 }
#endif

#endif
