/* 
    @(#)MFChart.h	1.9
    03/01/02 10:14:58
   
    PROGRAM NAME:  Manifold
   
    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.
   
    Please refer to the LICENSE file in the top directory

*/
/*      author: Mike Henderson mhender@watson.ibm.com */
/*      date:   February 18, 1999                     */

#ifndef __MFCHART_H__
#define __MFCHART_H__
#include <MFBase.h>

#include <MFNVector.h>
#include <MFKVector.h>
#include <MFNKMatrix.h>
#include <MFImplicitMF.h>
#include <MFPolytope.h>
#include <stdio.h>
#ifdef __cplusplus
extern "C"
 {
#endif
struct MFChartSt;
typedef struct MFChartSt *MFChart;

MFChart MFCreateChart(MFImplicitMF,MFNVector,MFNKMatrix,double);
void MFSubtractHalfSpaceFromChart(MFChart,int,MFKVector,double);
void MFRefChart(MFChart);
void MFFreeChart(MFChart);
MFPolytope MFChartPolytope(MFChart);
MFNVector MFChartCenter(MFChart);
MFNKMatrix MFChartTangentSpace(MFChart);
double MFChartRadius(MFChart);
int MFChartEvaluate(MFChart,MFKVector,MFNVector);
int MFChartInterior(MFChart,MFKVector);
int MFChartHasBoundary(MFChart);
int MFChartK(MFChart);
int MFChartN(MFChart);

void MFChartProjectIntoTangentSpace(MFChart,MFNVector,MFKVector);
void MFChartProjectVectorIntoTangentSpace(MFChart,MFNVector,MFKVector);
void MFChartPointInTangentSpace(MFChart,MFKVector,MFNVector);

void MFWriteChart(FILE*,MFChart);
struct MFAtlasSt;
MFChart MFReadChart(FILE*,struct MFAtlasSt*);

int MFChartGetPositionInBoundaryList(MFChart);
void MFChartSetPositionInBoundaryList(MFChart,int);
MFImplicitMF MFChartGetManifold(MFChart);
int MFChartIsSingular(MFChart);
void MFChartSetSingular(MFChart);
void MFChartSetNonSingular(MFChart);
void MFChartSetNonSingular(MFChart);

void MFChartClean(MFChart);
int MFChartPageOut(MFChart,FILE*,int);
int MFChartPaged(MFChart);

int MFChartNearBoundary(MFChart);
void MFChartSetNearBoundary(MFChart,int);

int MFChartNumberOfFaces(MFChart);

double MFChartSuggestedRadius(MFChart);
void MFSetSuggestedChartRadius(MFChart,double);

int MFChartReferenceNumber(MFChart);
void MFChartSetReferenceNumber(MFChart,int);
#ifdef __cplusplus
 }
#endif

#endif
