/* 
    @(#)MFKVector.h	1.3
    02/04/19 14:41:38
   
    PROGRAM NAME:  Manifold
   
    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.
   
    Please refer to the LICENSE file in the top directory

*/
/*      author: Mike Henderson mhender@watson.ibm.com */
/*      date:   November 11, 1997                     */
/*              February 2, 1999   Ported to C        */

#ifndef __MFKVECTOR_H__
#define __MFKVECTOR_H__
#include <MFBase.h>

#include <stdio.h>
#ifdef __cplusplus
extern "C"
 {
#endif
struct MFKVectorSt;
typedef struct MFKVectorSt *MFKVector;

MFKVector MFCreateKVector(int);
MFKVector MFCreateKVectorWithData(int,double*);
void MFRefKVector(MFKVector);
void MFFreeKVector(MFKVector);
int MFKV_NC(MFKVector);
double MFKV_C(MFKVector,int);
void MFKVSetC(MFKVector,int,double);

double MFKVDot(MFKVector,MFKVector);
double MFKVNorm(MFKVector);
void MFKVScale(double,MFKVector);
void MFKVScaleMul(double,MFKVector,MFKVector);
void MFKVDiff(MFKVector,MFKVector,MFKVector);
void MFKVAdd(MFKVector,MFKVector,MFKVector);

void MFWriteKVector(FILE*,MFKVector);
MFKVector MFReadKVector(FILE*);
#ifdef __cplusplus
 }
#endif
#endif
