/* 
    @(#)MFNSpace.h	1.8
    02/05/24 10:30:49
   
    PROGRAM NAME:  Manifold
   
    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.
   
    Please refer to the LICENSE file in the top directory

*/
/*      author: Mike Henderson mhender@watson.ibm.com */
/*      date:   November 11, 1997                     */
/*              February 2, 1999   Ported to C        */

#ifndef __MFNSPACE_H__
#define __MFNSPACE_H__
#include <MFBase.h>

#include <stdio.h>
#include <MFNVector.h>
#ifdef __cplusplus
extern "C"
 {
#endif

struct MFNSpaceSt;
typedef struct MFNSpaceSt *MFNSpace;

MFNSpace MFCreateNSpace(int);
MFNSpace MFCreateWeightedNSpace(int,int,double);
MFNSpace MFCreateTPBVPNSpace(int,int,int);
MFNSpace MFCreateNSpaceWithExponents(int,int*);
MFNSpace MFCreateWeightedNSpaceWithExponents(int,int,double,int*);
void MFRefNSpace(MFNSpace);
void MFFreeNSpace(MFNSpace);

double MFNSpaceInner(MFNSpace,MFNVector,MFNVector);
double MFNSpaceDistance(MFNSpace,MFNVector,MFNVector);
double MFNSpaceDistance(MFNSpace,MFNVector,MFNVector);
struct MFNKMatrixSt;
double MFNSpaceTangentDistance(MFNSpace,struct MFNKMatrixSt*,struct MFNKMatrixSt*);

void MFNSpaceDirection(MFNSpace,MFNVector,MFNVector,MFNVector);
void MFNSpaceAdd(MFNSpace,MFNVector,MFNVector,MFNVector);
void MFNSpaceScale(MFNSpace,double,MFNVector,MFNVector);

void MFWriteNSpace(FILE*,MFNSpace);
MFNSpace MFReadNSpace(FILE*);

MFNSpace MFCreateNSpaceBaseClass(char*);

void MFNSpaceSetDistance(MFNSpace,double (*distance)(MFNSpace,MFNVector,MFNVector,void*));
void MFNSpaceSetInnerProduct(MFNSpace,double (*inner)(MFNSpace,MFNVector,MFNVector,void*));
void MFNSpaceSetDirection(MFNSpace,void (*distance)(MFNSpace,MFNVector,MFNVector,MFNVector,void*));
void MFNSpaceSetAdd(MFNSpace,void (*add)(MFNSpace,MFNVector,MFNVector,MFNVector,void*));
void MFNSpaceSetScale(MFNSpace,void (*scale)(MFNSpace,double,MFNVector,MFNVector,void*));
void MFNSpaceSetWriteData(MFNSpace,void (*writedata)(FILE*,MFNSpace,void*));
void MFNSpaceSetFreeData(MFNSpace,void (*freedata)(void *));
void MFNSpaceSetData(MFNSpace,void*);
void *MFNSpaceGetData(MFNSpace);
char *MFNSpaceGetId(MFNSpace);
#ifdef __cplusplus
 }
#endif
#endif
