/* 
    @(#)MFPolytope.h	1.6
    02/11/11 15:04:50
   
    PROGRAM NAME:  Manifold
   
    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.
   
    Please refer to the LICENSE file in the top directory

*/
/*      author: Mike Henderson mhender@watson.ibm.com */

#ifndef __NEWPOLYTOPE_H__
#define __NEWPOLYTOPE_H__
#include <MFBase.h>

#include <stdio.h>
#include <MFKVector.h>
#ifdef __cplusplus
extern "C"
 {
#endif

struct MFPolytopeSt;
typedef struct MFPolytopeSt *MFPolytope;

MFPolytope MFCreateHyperCubeAtOrigin(int,double);
MFPolytope MFCreateSimplexAtOrigin(int,double);
void MFSubtractHalfSpaceFromPolytope(MFPolytope,int,MFKVector,double);
void MFClipPolytope(MFPolytope P,int,double*,int);
void MFFreePolytope(MFPolytope);

int MFPolytopeDimension(MFPolytope);
int MFPolytopeNumberOfVertices(MFPolytope);
void MFPolytopeVertex(MFPolytope,int,MFKVector);
int MFPolytopeVertexIndex(MFPolytope,int,int);
int MFPolytopeNumberOfVertexIndices(MFPolytope,int);
double MFPolytopeRadiusOfVertex(MFPolytope,int);
double MFPolytopeLargestRadiusOfVertex(MFPolytope);

int MFPolytopeNumberOfFaces(MFPolytope);
int MFPolytopeFaceIndex(MFPolytope,int);
MFKVector MFPolytopeFaceNormal(MFPolytope,int);
double MFPolytopeFaceOrigin(MFPolytope,int);
int MFPolytopeNumberOfVerticesOnFace(MFPolytope,int);

int MFPolytopeInterior(MFPolytope,MFKVector);
MFPolytope MFPolytopeRemoveSmallEdges(MFPolytope,double);

void MFWritePolytope(FILE*,MFPolytope);
MFPolytope MFReadPolytope(FILE*);
int MFPolytopeClosestFace(MFPolytope,MFKVector,double*);

void MFPolytopeSetVertexMark(MFPolytope,int,int);
int MFPolytopeGetVertexMark(MFPolytope,int);
#ifdef __cplusplus
 }
#endif
#endif
