/* 
    @(#)Compute4Space.c	1.4
    02/04/19 14:46:43
   
    PROGRAM NAME:  Manifold
   
    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.
   
    Please refer to the LICENSE file in the top directory

*/
/*      author: Mike Henderson mhender@watson.ibm.com */

#include <MFAtlas.h>
#include <MFNRegion.h>
#include <MFNVector.h>
#include <math.h>

int main(int argc, char *argv[])
 {
  MFImplicitMF M;
  int i;
  int n,k;
  MFNRegion Omega;
  MFAtlas S;
  MFNVector u0;
  FILE *fid;
  double R=.5;
  MFContinuationMethod H;

  k=4;
  M=MFIMFCreateNSpaceWithRadius(k,.1);
  n=MFIMF_N(M);
  Omega=MFNRegionCreateHyperCube(n,R);
  printf("Interior of Four Cube, volume=%lf\n",2*R*2*R*2*R*2*R);

  u0=MFCreateNVector(n);
  for(i=0;i<k;i++)
   {
    MFNVSetC(u0,i, 0.);
   }

  H=MFCreateHendersonsMethod();
  MFHendersonsMethodSetEpsilon(H,.1);
  MFHendersonsMethodSetMaxCharts(H,-1);
  MFHendersonsMethodSetVerbose(H,1);
  MFHendersonsMethodSetPage(H,0);

  S=MFComputeAtlas(H,M,Omega,u0);

/*fid=fopen("FourSpace.atlas","w");
  MFWriteAtlas(fid,S);
  fclose(fid);
  printf("Done writing Atlas\n");fflush(stdout);*/

  MFFreeAtlas(S);
  MFFreeImplicitMF(M);
  MFFreeNRegion(Omega);
  MFFreeNVector(u0);

  return(0);
 }
